#ifndef __ADULTE_H__
#define __ADULTE_H__

#include "personne.h"
#include <fstream>


/**
 * Classe representant un adulte (caracterise par sa profession).
 */
class Adulte : public Personne {

// ATTRIBUTS DE LA CLASSE
protected:
    /** Profession de l'adulte. */
    string _profession;

// METHODES PUBLIQUES
public:
    //-----------------------------
    // Constructeurs/destructeurs
    //-----------------------------
    /** Constructeur par defaut. */
    Adulte();
    /** Constructeur par initialisation. */
    Adulte(const string & prenom, const string & nom, const Date & date, const string & profession);
    /** Constructeur par copie. */
    Adulte(const Adulte &);
    /** Destructeur. */
    virtual ~Adulte();

    //-----------------------------
    // Selecteurs
    //-----------------------------
    const string & getProfession() const;
    /** Mise a jour de la profession. */
    void setProfession(const string & profession);

    //-----------------------------
    // Methodes
    //-----------------------------
    /** output de enfant (par defaut dans la sortie standard) */
    virtual void output(ostream & flux=cout) const;
    /** inout de enfant (par defaut via le clavier) */
    virtual void input(istream & flux=cin);;


    Personne * clone()const;

};

Personne * creerPersonne();

#endif // ifndef __ADULTE_H__

