#include <string.h>

#include "enfant.h"


//-----------------------------
// Constructeurs/destructeurs
//-----------------------------

// tout enfant est scolarise
Enfant::Enfant() : Personne() {// ici on fait appel au constructeur par défaut de la classe Personne
  _scolarise = true;
}

Enfant::Enfant(const string & prenom, const string nom, const Date & date, bool scolarise) : Personne(prenom, nom, date) {
  _scolarise = scolarise;
}

Enfant::Enfant(const Enfant & e) : Personne(e) {
  _scolarise = e.getScolarise();
}

Enfant::~Enfant() {
}



//-----------------------------
// Selecteurs
//-----------------------------
bool Enfant::getScolarise() const {
  return (_scolarise);
}

void Enfant::setScolarise(bool scolarise) {
  _scolarise = scolarise;
}



//-----------------------------
// Methodes
//-----------------------------
void Enfant::output(ostream & flux) const{
  flux << "Enfant : " << endl;
  Personne::output(flux);
  if (_scolarise){
    flux << "scolarise ";
  }
  else{
    flux << "non scolarise ";
  }
}

void Enfant::input(istream & flux) {
  Personne::input(flux);
  if (flux==cin){
    cout << "Scolarise (0 non - 1 oui) ? " << endl;
  }
  bool tmp;
  flux>>tmp;
  setScolarise(tmp);
}

Personne * Enfant::clone()const{
  Personne * res = new Enfant(*this);
  return res;
}




ifstream & operator >> (ifstream & fi, Enfant & e) {
 // fi>>((Personne)e;
  bool tmp;
  fi >> tmp;
  e.setScolarise(tmp);
  return fi;
}


ofstream & operator << (ofstream & fo, const Enfant &e) {
//  fo<<((Personne)e;
  fo << e.getScolarise() << endl;

  return fo;
}


