#ifndef __ENFANT_H__
#define __ENFANT_H__

#include "personne.h"
#include <fstream>


class Enfant : public Personne {


// ATTRIBUTS DE LA CLASSE
protected:
  bool _scolarise;

// METHODES PUBLIQUES
public:
    //-----------------------------
    // Constructeurs/destructeurs
    //-----------------------------
    /** Constructeur par defaut. */
    Enfant();
    /** Constructeur par initialisation. */
    Enfant(const string & prenom, const string nom, const Date & date, bool scolarise);
    /** Constructeur par copie. */
    Enfant(const Enfant & e);
    /** Destructeur. */
    virtual ~Enfant();

    //-----------------------------
    // Selecteurs
    //-----------------------------
    bool getScolarise() const;
    /** Met a jour la classe de l'enfant. */
    void setScolarise(bool scolarise);

    //-----------------------------
    // Methodes
    //-----------------------------
    /** output de enfant (par defaut dans la sortie standard) */
    virtual void output(ostream & flux=cout) const;
    /** inout de enfant (par defaut via le clavier) */
    virtual void input(istream & flux=cin);


    Personne * clone()const;


};

#endif // ifndef __ENFANT_H__

