#include <string.h>

#include "personne.h"


//-----------------------------
// Constructeurs/destructeurs
//-----------------------------


Personne::Personne() {
		// _prenom et _nom : valeurs par défaut (constructeur par defaut de la classe string)
    // dateDeNaissance : valeur par defaut (constructeur par defaut de la classe Date)
}


Personne::Personne(const string & iPrenom, const string & iNom, const Date & iDate){
  _prenom = iPrenom; // appel à l'operateur =  de la classe string
  _nom = iNom; // appel à l'operateur = de la classe string
  _dateDeNaissance = iDate; // appel à l'operateur = de la classe Date
}


Personne::Personne(const Personne & p) {
  _prenom = p.getPrenom(); // operateur = de la classe string
  _nom = p.getNom(); // operateur = de la classe string
  _dateDeNaissance = p.getDateDeNaissance();  // operateur = de la classe Date
}


Personne::~Personne() {
}


//-----------------------------
// Selecteurs
//-----------------------------

const string & Personne::getNom() const{
  return _nom;
}

const string & Personne::getPrenom() const {
  return _prenom;
}

const Date & Personne::getDateDeNaissance() const {
	return _dateDeNaissance;
}


void Personne::setNom(const string & iNom) {
  _nom = iNom; //operateur = de la classe string
}


void Personne::setPrenom(const string & iPrenom) {
  _prenom = iPrenom; //operateur = de la classe string
}

void Personne::setDateDeNaissance(const Date & iDate) {
	_dateDeNaissance = iDate;//operateur = de la classe Date
}



//-----------------------------
// Methodes
//-----------------------------
void Personne::output(ostream & flux) const {
  flux <<"Prenom : "<< _prenom << endl;
  flux <<"Nom : "<<_nom << endl;
  flux<<"ne le : ";
  flux<<_dateDeNaissance;
}


void Personne::input(istream & flux){
  string tmp;
  if (flux==cin){
    cout << endl << "prenom: ";
  }
  flux >> tmp;
  setPrenom(tmp);

  if (flux==cin){
    cout << endl<< "nom: ";
  }
  flux >> tmp;
  setNom(tmp);

  if (flux==cin){
    cout << endl<<"Date de naissance: "<<endl;
  }
  Date d;
  flux >> d;
  setDateDeNaissance(d);
}



//-----------------------------
// Surcharges d'operateurs
//-----------------------------
Personne& Personne::operator = (const Personne & p) {
  setPrenom(p.getPrenom());
  setNom(p.getNom());
  setDateDeNaissance(p.getDateDeNaissance());
  return (*this);
}


bool Personne::operator < (const Personne & p) const {
  bool res = true;
  const string & nomP = p.getNom();
  if (_nom > nomP){ // operateur > de la classe string
   res = false;
  }
  else{
    if (_nom == nomP){ // meme nom (operateur == de la classe string)
      const string & prenomP = p.getPrenom();
      if (_prenom > prenomP){// operateur > de la classe string
        res = false;
      }
      else{
        if (_prenom == prenomP){ // meme prenom
          const Date & dateDeNaissanceP = p.getDateDeNaissance();
          res = (_dateDeNaissance < dateDeNaissanceP);  // operateur < de la classe Date
        }
      }
    }
  }
  return res;
}


bool Personne::operator > (const Personne & p) const {
  bool res = true;
  const string & nomP = p.getNom();
  if (_nom < nomP){
    res = false;
  }
  else{
    if (_nom == nomP){ // meme nom
      const string & prenomP = p.getPrenom();
      if (_prenom < prenomP){
        res = false;
      }
      else{
        if (_prenom ==  prenomP){ // meme prenom
          const Date & dateDeNaissanceP = p.getDateDeNaissance();
          res = (_dateDeNaissance > dateDeNaissanceP);
        }
      }
    }
  }
  return res;
}


bool Personne::operator == (const Personne & p) const {
  bool res = (_nom==p.getNom() && _prenom==p.getPrenom() && _dateDeNaissance==p.getDateDeNaissance());
  return res;
}


istream & operator >> (istream & fi, Personne & p) {
  p.input(fi); // methode virtuelle
  return fi;
}



ostream & operator << (ostream & fo, const Personne &p) {
  p.output(fo); //methode virtuelle
  return fo;
}


